/* common.h of iplog v1.7 -- eric@ojnk.org */
#ifndef __COMMON_H
#define __COMMON_H

#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <netdb.h>
#include <signal.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/syslog.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include "icmp-compat.h"

#define MIN(x, y) (x < y ? x : y)
#define LEVEL		LOGGING_PRIORITY
#define FIX(x)		network_byte_ordering(x)
#define UNFIX(x)	network_byte_ordering(x)

/* dns.c */
void sigunused(int stat);
void init_dns_cache(void);
char *get_dns_cache(u_long addr);
void add_dns_cache(u_long addr);
void expire_dns(void);

/* ident.c */
char *get_identd_data(u_short r_port, u_short l_port, u_long r_addr, u_long l_addr);

/* iplog.c */
int l_port(u_short port);
u_int16_t network_byte_ordering(u_int16_t x);
void fatal(const char *fmt,...);
void fork_to_background(void);
void assert_id(uid_t uid, gid_t gid);
void drop_privileges(void);
char *my_getpid(void);
void initialize_lockfile(char *p);
int portscan(struct in_addr *in);
void init_portscan(void);
void expire_portscan(void);
void sigalrm(int stat);
int comp(const void *a, const void *b);

/* smurf.h */
struct gen_packet {
	struct ip ip;
};

int smurf(struct gen_packet *pkt);

#endif
