/* ident.c of iplog v1.7 -- eric@ojnk.org */
#include "config.h"
#ifdef RETRIEVE_IDENTD
#include "common.h"
#include "ident.h"

char *get_identd_data(u_short r_port, u_short l_port, u_long r_addr, u_long l_addr)
{
	fd_set fd_read;
	int s, on = 1;
	struct linger lin =
	{0, 0};
	struct timeval tv =
	{10, 0};
	struct sockaddr_in sin;
	static char *user = NULL;
	char buf[512], temp[64];

	if ((s = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) != (-1L)) {
		(void)setsockopt(s, SOL_SOCKET, SO_LINGER, &lin, sizeof(lin));
		(void)setsockopt(s, SOL_SOCKET, SO_REUSEADDR, &on, sizeof(on));

		sin.sin_family = AF_INET;
		sin.sin_addr.s_addr = l_addr;
		sin.sin_port = INADDR_ANY;

		if (bind(s, (struct sockaddr *)&sin, sizeof(sin)) != INADDR_NONE) {
			memset((char *)&sin, 0, sizeof(sin));
			sin.sin_family = AF_INET;
			sin.sin_port = IDENTD_PORT;
			sin.sin_addr.s_addr = r_addr;

			if (connect(s, (struct sockaddr *)&sin, sizeof(sin)) != INADDR_NONE) {
				sprintf(buf, "%d , %d\r\n", UNFIX(r_port), UNFIX(l_port));
				send(s, buf, strlen(buf), 0);
				memset(buf, 0, sizeof(buf));
				memset(temp, 0, sizeof(temp));

				FD_ZERO(&fd_read);
				FD_SET(s, &fd_read);

				if (select(s + 1, &fd_read, NULL, NULL, &tv) > 0)
					if (recv(s, buf, 512, 0) > 0)
						if (sscanf(buf, IDENTD_FORMAT, temp) > 0)
							user = strdup(temp);

				(void)close(s);
			}
		}
	}
	return (user);
}


/* Check if a local port "port" is listening--if the connection was refused,
   identd on the remote host has closed the connection and thus has no data
   on the connection, which makes attempting to get the ident reply stupid. */

int l_port(u_short port)
{
	FILE *fp;
	unsigned int l_port, mode;
	char buf[BUFSIZ];

	if ((fp = fopen(TCP_DATA, "r")) == NULL)
		return 0;

	while (fgets(buf, sizeof(buf) - 1, fp) != NULL)
		if ((sscanf(buf, TCP_FORMAT, &l_port, &mode) == 2) && (UNFIX(l_port) == port) && (mode == TCP_LISTEN))
			break;

	(void)fclose(fp);

	if ((UNFIX(l_port) == port) && (mode == TCP_LISTEN))
		return 1;

	return 0;
}

#endif /* RETRIEVE_IDENTD */
