#!/bin/sh
# installation script for iplog v1.7

RCLOCAL="/etc/rc.d/rc.local"
INSTALL="/usr/local/sbin/tcplog /usr/local/sbin/icmplog /usr/local/sbin/udplog"

echo ""
echo -n "Do you want me to install iplog v1.7 in your rc.scripts? [y] "
read yesno

if [ "$yesno" = "n" ]; then
	exit 0
fi

for Z in ${INSTALL}; do
	if [ -x $Z ]; then
		X=`grep $Z $RCLOCAL`
		if [ "$X" != "" ]; then
			echo "`basename $Z` is already installed (good!)"
		else
			echo "$Z" >> $RCLOCAL
			echo "Installed `basename $Z` in $RCLOCAL.."
		fi
	fi
done

echo ""
echo -n "Do you want me to run the latest version of iplog v1.7 for you? [y]"
read yesno

if [ "$yesno" = "n" ]; then
	exit 0
fi

for Z in ${INSTALL}; do
	killall -TERM -i `basename $Z`
	echo "Now running $Z.."
	$Z
done

